import os
import ConfigParser
from shutil import copyfile
import filecmp


print "VALIDATION STARTING\n--------"
hwdir="/home/hardwareconfigurations"
swdir="/home/softwareconfigurations"
hwrestore="/opt/configrestore/hardwareconfigurations"
swrestore="/opt/configrestore/softwareconfigurations"

validatesections=["Header","input_data"]

def checkfile(filedir,restdir,filename):
    if not os.path.isfile(filedir+"/"+filename):
        print "Error: no file"
        return False
    config = ConfigParser.ConfigParser()
    config.read(filedir+"/"+filename)
    validator = ConfigParser.ConfigParser()
    validator.read(restdir+"/"+filename)
    for sect in validatesections:
        if not config.has_section(sect):
            print "Error: no section",sect
            return False
        
    options = validator.options(validatesections[1])
    for opt in options:
        if not config.has_option(validatesections[1],opt):
            print "Error: no option",opt,"in",validatesections[1]
            return False
    return True
        
def restorefile(source, destination):
    copyfile(source, destination)

if os.path.isfile("/mnt/rhothetarestore.rt5"):
    if filecmp.cmp("/mnt/rhothetarestore.rt5","/opt/scripts/rhothetarestore.rt5",True):
        for filename in os.listdir(swrestore):
            if filename.endswith(".cfg"):
                restorefile(swrestore+"/"+filename, swdir+"/"+filename)
        for filename in os.listdir(hwrestore):
            if filename.endswith(".cfg"):
                restorefile(hwrestore+"/"+filename, hwdir+"/"+filename)
	if os.path.exists("/data/pages/listOfPages.rt5"):
	    os.remove("/data/pages/listOfPages.rt5")
	if os.path.exists("/data/storage/secret.txt"):
	    os.remove("/data/storage/secret.txt")
    quit()


print "Validating hardware configurations:\n"            
for filename in os.listdir(hwrestore):
    if filename.endswith(".cfg"):
        print filename
        if filename == "pins.cfg":
            continue
        if not checkfile(hwdir,hwrestore,filename):
            restorefile(hwrestore+"/"+filename, hwdir+"/"+filename)
            print filename + " invalid, restoring!\n--------"
        else:
            print filename + " validated\n--------"

print "Validating software configurations:\n"            
for filename in os.listdir(swrestore):
    if filename.endswith(".cfg"):
        print filename
        if not checkfile(swdir,swrestore,filename):
            restorefile(swrestore+"/"+filename, swdir+"/"+filename)
            print filename + " invalid, restoring!\n--------"
        else:
            print filename + " validated\n--------"
