import os
import glob
import shutil
import zipfile
import hashlib

FALLBACK_TO_FACTORY=0
FALLBACK_TO_DEFAULT=1

def fallback_version(fallback_type):
    if fallback_type == FALLBACK_TO_FACTORY:
        print "Fallback to factory Application and configurations!"
        if not os.path.exists("/opt/application/bin/factory_application"):
            exit(0)
        #copy 
        shutil.copy2("/opt/application/bin/factory_application", "/opt/application/bin/application")

	BLOCKSIZE = 65536

	hasher = hashlib.md5()

	with open('/opt/application/bin/application', 'rb') as afile:
		buf = afile.read(BLOCKSIZE)

		while len(buf) > 0:
			hasher.update(buf)
			buf = afile.read(BLOCKSIZE)

	verify_file = open("/opt/application/bin/application.md5", "w")
	verify_file.write(hasher.hexdigest() + "  /opt/application/bin/application")	
        #copy configurations
        #zip_files = zipfile.ZipFile("/opt/application/bin/factory_cfgs.zip", "r")
        #zip_files.extractall("/home/")
        #zip_files.close()
        
    elif fallback_type == FALLBACK_TO_DEFAULT:
        print "Fallback to default Application, remove new version!"
        os.remove(glob.glob("/opt/application/bin/application_*")[0])
    if os.path.exists("/home/storage/appverification"):
	os.remove("/home/storage/appverification")
    exit(0)

if os.path.exists("/home/storage/version"):
    version_file = open("/home/storage/version", "r")
    version = version_file.read().strip()
    print "Last operational Application version: " + version
    version_file.close()
    os.remove("/home/storage/version")
else:
    version = ""
    
app_new_version = len(glob.glob("/opt/application/bin/application_*")) > 0
print app_new_version

version_error=False

if os.path.exists("/home/storage/appverification"):
    app_error = open("/home/storage/appverification","r")
    err = app_error.read().strip()
    version_error = (err == "error")

if not os.path.exists("/opt/application/bin/application"):
    version_error = True

##################
##   FALLBACK   ##
##################
if version is "" or version_error:
    if app_new_version:
        fallback_version(FALLBACK_TO_DEFAULT)
    else:
        fallback_version(FALLBACK_TO_FACTORY)

##################
##CHECK VERSION ##
##################

if not app_new_version:
    #start app
    exit(0)

app_version = str(glob.glob("/opt/application/bin/application_*")[0]).replace("/opt/application/bin/application_","").strip()
print app_version, version

if (app_version == version) and not version_error:
    print "Correct version, set new Application as Default Boot"
    shutil.move("/opt/application/bin/application_"+app_version, "/opt/application/bin/application")
    os.remove("/home/storage/appverification")
    exit(0)
elif os.path.exists("/home/storage/appverification"):
    verify_file = open("/home/storage/appverification", "w")
    verify_file.write("error")
    exit(0)
else:
    verify_file = open("/home/storage/appverification", "w")
    verify_file.write("testing")
    print "Starting new Application, verification needed."
    exit(1)

